import { r as registerInstance, h, g as getElement } from './core-095fd691.js';
import { l as linker } from './input-linker-2b74e80e.js';
var BceElementLinkTemplate = /** @class */ (function () {
    function class_1(hostRef) {
        registerInstance(this, hostRef);
        this.metadata = {};
        this.href = '';
        this.text = '';
        this.icon = '';
        this.labelHref = 'Reference';
        this.labelText = 'Text';
        this.labelIcon = 'Icon';
        this.placeholderHref = 'https://example.com';
        this.placeholderText = 'Example';
        this.placeholderIcon = 'globe';
        this._link = linker(this, this.handleInput);
        this._href = this._link('href');
        this._text = this._link('text');
        this._icon = this._link('icon');
    }
    class_1.prototype.handleInput = function (name, event) {
        var _a;
        var input = event.target;
        if (!input)
            return;
        event.cancelBubble = true;
        this[name] = input.value;
        this.value = this.updateValue((_a = {}, _a[name] = input.value, _a));
        this.el.dispatchEvent(new Event('input', { bubbles: true }));
    };
    class_1.prototype.updateValue = function (part) {
        if (part === void 0) { part = {}; }
        var current = {
            href: this.href,
            text: this.text,
            icon: this.icon,
            metadata: Object.assign({}, this.metadata)
        };
        return Object.assign({}, current, part);
    };
    class_1.prototype.componentDidLoad = function () {
        this.value = this.updateValue();
        this.el.dispatchEvent(new Event('input', { bubbles: true }));
    };
    class_1.prototype.render = function () {
        return [
            h("bce-input", Object.assign({ type: "text" }, this._href)),
            h("bce-input", Object.assign({ type: "text" }, this._text)),
            h("bce-input", Object.assign({ type: "text" }, this._icon))
        ];
    };
    Object.defineProperty(class_1.prototype, "el", {
        get: function () { return getElement(this); },
        enumerable: true,
        configurable: true
    });
    return class_1;
}());
export { BceElementLinkTemplate as bce_element_link_template };
